local options = MissionMinder.options;
local L = LibStub("AceLocale-3.0"):GetLocale("MissionMinder");
local DEBUG = MissionMinder.debug;

MissionMinder.autoclose = {};
local addon = MissionMinder.autoclose;

local AUTOCLOSE_FAILED_DELAY = 1.0
local AUTOCLOSE_SUCCESS_DELAY = 1.5;


local function hideCompleteMission()
	GarrisonMissionFrame_HideCompleteMissions(true);
end

local function closeCompletionFrame(delay)
	C_Timer.After(delay, hideCompleteMission);
end

local function hideNextMissionButton(...)
	local self = GarrisonMissionFrame.MissionComplete;

	if ( options.AutoClose() ) then
		self.NextMissionButton:Hide();
		self.ButtonFrame:Hide();
	else
		self.NextMissionButton:Show();
		self.ButtonFrame:Show();
	end
end

local function autoCloseMissionFailed()
	if ( options.AutoClose() ) then
		local currentMission = GarrisonMissionFrame.MissionComplete.currentMission;
		if ( currentMission and not currentMission.succeeded ) then
			closeCompletionFrame(AUTOCLOSE_FAILED_DELAY);
		end
	end
end

local function closeOnSuccessfulLoot(...)
	if ( options.AutoClose() ) then
		closeCompletionFrame(AUTOCLOSE_SUCCESS_DELAY);
	end
end

function addon.initialize()
	-- Hide the next mission button when the MissionComplete frame shows
	local MissionComplete = GarrisonMissionFrame.MissionComplete;
	MissionComplete:HookScript("OnShow", hideNextMissionButton);

	-- Auto close on successful loot
	local bonusRewards = GarrisonMissionFrame.MissionComplete.BonusRewards;
	bonusRewards.ChestModel.OpenAnim:HookScript("OnFinished", closeOnSuccessfulLoot);

	-- Auto close on failure
	GarrisonMissionFrame.MissionComplete.ChanceFrame.FailureAnim:HookScript("OnFinished", autoCloseMissionFailed);
end